## libheif 1.18.1

=== debian/changelog ===
libheif (1.18.1-2) unstable; urgency=medium

  * Fix trailing comma in description.
  * d/control: Add reason for architecture list of librav1e-dev dependency.
  * d/rules: Disable uncompressed codec which doesn't work correctly on big-endian systems.
  * d/control: Add links to used libraries to plugin package descriptions.
  * Add decoding smoke test.

 -- Joachim Bauch <bauch@struktur.de>  Wed, 28 Aug 2024 11:33:20 +0200

libheif (1.18.1-1) unstable; urgency=medium

  * New upstream version 1.18.1
  * Remove patches now part of the upstream release.
  * Add patch to fix detection of OpenJPEG 2 in Debian.
  * Update libheif-examples for renamed and symlinked tool.
  * Update symbols for new upstream version.
  * d/copyright: Add more details and update for new upstream version.
  * Add symlink for manpage of renamed and symlinked tool from libheif-examples.
  * Update package descriptions.

 -- Joachim Bauch <bauch@struktur.de>  Thu, 01 Aug 2024 12:13:56 +0200

libheif (1.17.6-4) unstable; urgency=medium

  * Add kvazaar plugin (Closes: #1072007).
  * d/copyright: Update DEP-5 license ids, add missing exceptions.

 -- Joachim Bauch <bauch@struktur.de>  Mon, 24 Jun 2024 09:43:29 +0200

=== debian/control ===
Source: libheif
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Joachim Bauch <bauch@struktur.de>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libaom-dev,
 libavcodec-dev,
 libdav1d-dev,
 libde265-dev (>= 1.0.7),
 libgdk-pixbuf-2.0-dev,
 libjpeg-dev,
 libkvazaar-dev,
 libopenjp2-7-dev,
 libpng-dev,
# librav1e-dev is built by src:rust-rav1e which is not available on all platforms.
# Make sure to use the same list in the "libheif-plugin-rav1e" package below.
 librav1e-dev [amd64 arm64 armel armhf mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x],
 libsharpyuv-dev,
 libsvtav1enc-dev,
 libx265-dev,
 pkgconf
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: http://www.libheif.org
Vcs-Git: https://salsa.debian.org/multimedia-team/libheif.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/libheif

Package: libheif1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${libheif:Depends},
 libheif-plugin-libde265 (= ${binary:Version})
Recommends:
 ${libheif:Recommends},
 libheif-plugin-aomenc (= ${binary:Version})
Suggests:
 ${libheif:Suggests},
 libheif-plugin-ffmpegdec (= ${binary:Version}),
 libheif-plugin-jpegdec (= ${binary:Version}),
 libheif-plugin-jpegenc (= ${binary:Version}),
 libheif-plugin-j2kdec (= ${binary:Version}),
 libheif-plugin-j2kenc (= ${binary:Version}),
 libheif-plugin-kvazaar (= ${binary:Version}),
 libheif-plugin-rav1e (= ${binary:Version}),
 libheif-plugin-svtenc (= ${binary:Version})
Description: HEIF and AVIF file format decoder and encoder - shared library
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the shared library.

Package: libheif-plugin-aomdec
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - aomdec plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the aomdec plugin that uses libaom to decode AV1 images.
 .
 libaom: https://aomedia.org/

Package: libheif-plugin-aomenc
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - aomenc plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the aomenc plugin that uses libaom to encode AV1 images.
 .
 libaom: https://aomedia.org/

Package: libheif-plugin-dav1d
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - dav1d plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the dav1d plugin that uses dav1d to decode AV1 images.
 .
 dav1d: https://www.videolan.org/projects/dav1d.html

Package: libheif-plugin-ffmpegdec
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - ffmpegdec plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the ffmpegdec plugin that uses FFmpeg to decode HEVC
 images. It can make use of H265 hardware decoders if available in FFmpeg.
 .
 FFmpeg: https://www.ffmpeg.org/

Package: libheif-plugin-j2kdec
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - j2kdec plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the j2kdec plugin that uses OpenJPEG to decode JPEG2000
 images.
 .
 OpenJPEG: https://www.openjpeg.org/

Package: libheif-plugin-j2kenc
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - j2kenc plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the j2kenc plugin that uses OpenJPEG to encode JPEG2000
 images.
 .
 OpenJPEG: https://www.openjpeg.org/

Package: libheif-plugin-jpegdec
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - jpegdec plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the jpegdec plugin that uses libjpeg to decode JPEG
 images.
 .
 libjpeg: https://www.libjpeg-turbo.org/

Package: libheif-plugin-jpegenc
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - jpegenc plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the jpegenc plugin that uses libjpeg to encode JPEG
 images.
 .
 libjpeg: https://www.libjpeg-turbo.org/

Package: libheif-plugin-kvazaar
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - kvazaar plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the kvazaar plugin that uses kvazaar to encode HEVC
 images.
 .
 kvazaar: https://ultravideo.fi/kvazaar.html

Package: libheif-plugin-libde265
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - libde265 plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the libde265 plugin that uses libde265 to decode HEVC
 images.
 .
 libde265: https://www.libde265.org/

Package: libheif-plugin-rav1e
Architecture: amd64 arm64 armel armhf mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - rav1e plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the rav1e plugin that uses rav1e to encode AV1 images.
 .
 rav1e: https://github.com/xiph/rav1e

Package: libheif-plugin-svtenc
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - svtenc plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the svtenc plugin that uses SVT-AV1 to encode AV1 images.
 .
 SVT-AV1: https://gitlab.com/AOMediaCodec/SVT-AV1

Package: libheif-plugin-x265
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - x265 plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/pkg-info.mk

PKD = $(abspath $(dir $(MAKEFILE_LIST)))
PKG = $(DEB_SOURCE)
VER = $(DEB_VERSION_UPSTREAM)
COMMIT = $$(git log -1 --pretty=%h)
LAST_TAG=$$(git describe --tags --abbrev=0)
COUNT_SINCE_LAST_TAG=$$(git rev-list $(LAST_TAG).. --count)
BASENAME=$(PKG)_$(VER)+$(COUNT_SINCE_LAST_TAG)+git$(COMMIT)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

rav1e_archs = $(shell sed -n 's/.*\blibrav1e-dev[[:space:]]*\[\(.*\)\].*/\1/p' debian/control)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DCMAKE_INSTALL_INCLUDEDIR=include/$(DEB_HOST_MULTIARCH) \
		-DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" \
		-DPLUGIN_DIRECTORY=/usr/lib/$(DEB_HOST_MULTIARCH)/libheif/plugins \
		-DWITH_AOM_DECODER_PLUGIN=ON \
		-DWITH_AOM_ENCODER_PLUGIN=ON \
		-DWITH_DAV1D=ON \
		-DWITH_DAV1D_PLUGIN=ON \
		-DWITH_DEFLATE_HEADER_COMPRESSION=ON \
		-DWITH_FFMPEG_DECODER=ON \
		-DWITH_FFMPEG_DECODER_PLUGIN=ON \
		-DWITH_JPEG_DECODER=ON \
		-DWITH_JPEG_DECODER_PLUGIN=ON \
		-DWITH_JPEG_ENCODER=ON \
		-DWITH_JPEG_ENCODER_PLUGIN=ON \
		-DWITH_KVAZAAR=ON \
		-DWITH_KVAZAAR_PLUGIN=ON \
		-DWITH_LIBDE265_PLUGIN=ON \
		-DWITH_LIBSHARPYUV=ON \
		-DWITH_OpenJPEG_DECODER=ON \
		-DWITH_OpenJPEG_DECODER_PLUGIN=ON \
		-DWITH_OpenJPEG_ENCODER=ON \
		-DWITH_OpenJPEG_ENCODER_PLUGIN=ON \
		-DWITH_X265_PLUGIN=ON \
		-DWITH_RAV1E=$(if $(filter $(DEB_HOST_ARCH),$(rav1e_archs)),ON,OFF) \
		-DWITH_RAV1E_PLUGIN=$(if $(filter $(DEB_HOST_ARCH),$(rav1e_archs)),ON,OFF) \
		-DWITH_SvtEnc=ON \
		-DWITH_SvtEnc_PLUGIN=ON

override_dh_auto_test:
	LIBHEIF_PLUGIN_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/libheif/plugins ./debian/tests/test-decode
	LIBHEIF_PLUGIN_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/libheif/plugins dh_auto_test

# some dependencies are in Ubuntu "universe"
# https://launchpad.net/bugs/2004453 https://launchpad.net/bugs/2004446
override_dh_gencontrol:
ifeq ($(shell dpkg-vendor --query vendor),Ubuntu)
	dh_gencontrol -- \
		-Vlibheif:Depends='libheif-plugin-aomdec (= $${binary:Version}) | libheif-plugin-dav1d (= $${binary:Version})' \
		-Vlibheif:Suggests:'libheif-plugin-x265 (= $${binary:Version})'
else
	dh_gencontrol -- \
		-Vlibheif:Depends='libheif-plugin-dav1d (= $${binary:Version}) | libheif-plugin-aomdec (= $${binary:Version})' \
		-Vlibheif:Recommends:'libheif-plugin-x265 (= $${binary:Version})'
endif

UURL = git://github.com/strukturag/libheif.git
get-head-source:
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting.))
	@echo "# Downloading..."
	git clone $(UURL) $(PKG)-$(VER) \
		|| $(RM) -r $(PKG)-$(VER)
	cd $(PKG)-$(VER) \
	&& echo "# Checking out commit $(COMMIT)..." \
	&& git checkout -q $(COMMIT) \
	&& echo "# Setting times..." \
	&& git ls-tree -r --name-only HEAD | while read F ; do touch --no-dereference -d "@$$(git log -1 --format="%ct" -- "$$F")" "$$F"; done \
	&& echo "# Writing to $(BASENAME).orig.tar.xz..." \
	&& find -L . -xdev -type f -not -path "*/.git/*" -print | LC_ALL=C sort \
		| XZ_OPT="-6v" tar -caf "../$(BASENAME).orig.tar.xz" -T- --transform "s/^\./$(BASENAME)/g" --owner=root --group=root --mode=a+rX
	@echo "# Cleaning up..." \
	&& $(RM) -r "$(PKG)-$(VER)"

## libheif 1.19.1

=== debian/changelog ===
libheif (1.19.1-1~bpo12+2) bookworm-backports; urgency=medium

  * Fix bug number of backport request.

 -- Joachim Bauch <fancycode@debian.org>  Sun, 10 Nov 2024 23:08:13 +0100

libheif (1.19.1-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports (Closes: #1083219).
  * Don't build against libsharpyuv-dev, not present in bookworm.
  * Don't build kvazaar plugin, dependencies not present in bookworm.

 -- Joachim Bauch <fancycode@debian.org>  Sun, 10 Nov 2024 21:27:29 +0100

libheif (1.19.1-1) unstable; urgency=medium

  * Explicitly Build-Depend on libz-dev instead of pulling automagically.
  * New upstream version 1.19.1
  * d/rules: Enabled uncompressed codec (fixed upstream, Closes: #1077762).
  * Update symbols for new upstream version.
  * Adjust name of define to enable header compression.
  * Update patch for new upstream version.
  * d/rules: Check DEB_BUILD_OPTIONS in "override_dh_auto_test".

 -- Joachim Bauch <fancycode@debian.org>  Mon, 04 Nov 2024 09:56:34 +0100

libheif (1.18.2-2) unstable; urgency=medium

  * d/control: Only depend on rav1e plugin on architectures where it exists.

 -- Joachim Bauch <fancycode@debian.org>  Thu, 26 Sep 2024 09:05:32 +0200

libheif (1.18.2-1) unstable; urgency=medium

  * Change to use my @debian.org address.
  * New upstream version 1.18.2
  * d/control: Add metapackage "libheif-plugins-all" depending on all plugins.
  * d/control: Update dependencies of -dev package for plugin packages.
  * No need to manually symlink example, done by upstream.

 -- Joachim Bauch <fancycode@debian.org>  Tue, 24 Sep 2024 10:45:02 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
- Joachim Bauch <bauch@struktur.de>
+ Joachim Bauch <fancycode@debian.org>
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
@@ -13,15 +13,14 @@
  libde265-dev (>= 1.0.7),
  libgdk-pixbuf-2.0-dev,
  libjpeg-dev,
- libkvazaar-dev,
  libopenjp2-7-dev,
  libpng-dev,
 # librav1e-dev is built by src:rust-rav1e which is not available on all platforms.
 # Make sure to use the same list in the "libheif-plugin-rav1e" package below.
  librav1e-dev [amd64 arm64 armel armhf mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x],
- libsharpyuv-dev,
  libsvtav1enc-dev,
  libx265-dev,
+ libz-dev,
  pkgconf
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
@@ -47,8 +46,7 @@
  libheif-plugin-jpegenc (= ${binary:Version}),
  libheif-plugin-j2kdec (= ${binary:Version}),
  libheif-plugin-j2kenc (= ${binary:Version}),
- libheif-plugin-kvazaar (= ${binary:Version}),
- libheif-plugin-rav1e (= ${binary:Version}),
+ libheif-plugin-rav1e (= ${binary:Version}) [amd64 arm64 armel armhf mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x],
  libheif-plugin-svtenc (= ${binary:Version})
 Description: HEIF and AVIF file format decoder and encoder - shared library
  libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
@@ -244,29 +242,6 @@
  .
  libjpeg: https://www.libjpeg-turbo.org/
 
-Package: libheif-plugin-kvazaar
-Architecture: any
-Multi-Arch: same
-Depends:
- libheif1 (= ${binary:Version}),
- ${misc:Depends},
- ${shlibs:Depends}
-Description: HEIF and AVIF file format decoder and encoder - kvazaar plugin
- libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
- format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
- (2nd Edition) capabilities.
- .
- HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
- coding, respectively, for the best compression ratios currently possible.
- .
- libheif supports various codecs provided by plugins for image decoding and
- encoding.
- .
- This package contains the kvazaar plugin that uses kvazaar to encode HEVC
- images.
- .
- kvazaar: https://ultravideo.fi/kvazaar.html
-
 Package: libheif-plugin-libde265
 Architecture: any
 Multi-Arch: same
@@ -343,3 +318,25 @@
  ${shlibs:Depends}
 Description: HEIF and AVIF file format decoder and encoder - x265 plugin
  libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
+ format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
+ (2nd Edition) capabilities.
+ .
+ HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
+ coding, respectively, for the best compression ratios currently possible.
+ .
+ libheif supports various codecs provided by plugins for image decoding and
+ encoding.
+ .
+ This package contains the x265 plugin that uses x265 to encode HEVC images.
+ .
+ x265: https://www.videolan.org/developers/x265.html
+
+Package: libheif-plugins-all
+Architecture: any
+Multi-Arch: same
+Depends:
+ libheif-plugin-aomdec (>= ${source:Version}),
+ libheif-plugin-aomenc (>= ${source:Version}),
+ libheif-plugin-dav1d (>= ${source:Version}),
+ libheif-plugin-ffmpegdec (>= ${source:Version}),
+ libheif-plugin-j2kdec (>= ${source:Version}),

=== debian/rules ===
--- 
+++ 
@@ -28,17 +28,14 @@
 		-DWITH_AOM_ENCODER_PLUGIN=ON \
 		-DWITH_DAV1D=ON \
 		-DWITH_DAV1D_PLUGIN=ON \
-		-DWITH_DEFLATE_HEADER_COMPRESSION=ON \
+		-DWITH_HEADER_COMPRESSION=ON \
 		-DWITH_FFMPEG_DECODER=ON \
 		-DWITH_FFMPEG_DECODER_PLUGIN=ON \
 		-DWITH_JPEG_DECODER=ON \
 		-DWITH_JPEG_DECODER_PLUGIN=ON \
 		-DWITH_JPEG_ENCODER=ON \
 		-DWITH_JPEG_ENCODER_PLUGIN=ON \
-		-DWITH_KVAZAAR=ON \
-		-DWITH_KVAZAAR_PLUGIN=ON \
 		-DWITH_LIBDE265_PLUGIN=ON \
-		-DWITH_LIBSHARPYUV=ON \
 		-DWITH_OpenJPEG_DECODER=ON \
 		-DWITH_OpenJPEG_DECODER_PLUGIN=ON \
 		-DWITH_OpenJPEG_ENCODER=ON \
@@ -47,11 +44,14 @@
 		-DWITH_RAV1E=$(if $(filter $(DEB_HOST_ARCH),$(rav1e_archs)),ON,OFF) \
 		-DWITH_RAV1E_PLUGIN=$(if $(filter $(DEB_HOST_ARCH),$(rav1e_archs)),ON,OFF) \
 		-DWITH_SvtEnc=ON \
-		-DWITH_SvtEnc_PLUGIN=ON
+		-DWITH_SvtEnc_PLUGIN=ON \
+		-DWITH_UNCOMPRESSED_CODEC=ON
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	LIBHEIF_PLUGIN_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/libheif/plugins ./debian/tests/test-decode
 	LIBHEIF_PLUGIN_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/libheif/plugins dh_auto_test
+endif
 
 # some dependencies are in Ubuntu "universe"
 # https://launchpad.net/bugs/2004453 https://launchpad.net/bugs/2004446

## libheif 1.19.3

=== debian/changelog ===
libheif (1.19.3-1~bpo12+1) bookworm-backports; urgency=medium

  * d/control: Remove "libsharpyuv-dev" from dependencies of "-dev" package,
    not present in bookworm.

 -- Joachim Bauch <fancycode@debian.org>  Sat, 16 Nov 2024 13:46:22 +0100

libheif (1.19.3-1) unstable; urgency=medium

  * New upstream version 1.19.3
  * d/rules: Don't treat all warnings as errors (matches upstream "release"
    preset).

 -- Joachim Bauch <fancycode@debian.org>  Mon, 11 Nov 2024 16:04:55 +0100

## libheif 1.19.5

=== debian/changelog ===
libheif (1.19.5-1) unstable; urgency=medium

  * New upstream version 1.19.5
  * d/copyright: Update entry for renamed files.

 -- Joachim Bauch <fancycode@debian.org>  Tue, 07 Jan 2025 13:23:42 +0100

## libheif 1.19.7

=== examples/CMakeLists.txt ===
# Needed to find libheif/heif_version.h while compiling the library
include_directories(${libheif_BINARY_DIR} ${libheif_SOURCE_DIR}/libheif/api ${libheif_SOURCE_DIR}/libheif)

if (MSVC)
    set(getopt_sources
            ../extra/getopt.c
            ../extra/getopt.h
            ../extra/getopt_long.c
            )
    include_directories("../extra")
endif ()

add_executable(heif-info ${getopt_sources}
        heif_info.cc
        common.cc
        common.h)
target_link_libraries(heif-info heif)
install(TARGETS heif-info RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES heif-info.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)


add_executable(heif-dec ${getopt_sources}
        heif_dec.cc
        common.cc
        common.h)
target_link_libraries(heif-dec PRIVATE heif heifio)
target_include_directories(heif-dec PRIVATE ${libheif_SOURCE_DIR})
install(TARGETS heif-dec RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES heif-dec.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

# create symbolic link from the old name `heif-convert` to `heif-dec`
if(NOT WIN32)
  install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink heif-dec${CMAKE_EXECUTABLE_SUFFIX} \$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/heif-convert${CMAKE_EXECUTABLE_SUFFIX})")
else()
  install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/heif-dec${CMAKE_EXECUTABLE_SUFFIX} ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/heif-convert${CMAKE_EXECUTABLE_SUFFIX})")
endif()


add_executable(heif-enc ${getopt_sources}
        heif_enc.cc
        benchmark.h
        benchmark.cc
        common.cc
        common.h)
target_link_libraries(heif-enc PRIVATE heif heifio)
target_include_directories(heif-enc PRIVATE ${libheif_SOURCE_DIR})
install(TARGETS heif-enc RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES heif-enc.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

if (WITH_HEADER_COMPRESSION)
    target_compile_definitions(heif-enc PRIVATE WITH_HEADER_COMPRESSION=1)
endif ()


if (PNG_FOUND)
    add_executable(heif-thumbnailer ${getopt_sources}
            heif_thumbnailer.cc
            common.cc
            common.h)
    target_link_libraries(heif-thumbnailer heif heifio)
    target_include_directories(heif-thumbnailer PRIVATE ${libheif_SOURCE_DIR})

    install(TARGETS heif-thumbnailer RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
    install(FILES heif-thumbnailer.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
endif()

add_executable(heif-test ${getopt_sources}
        heif_test.cc
        common.cc
        common.h)
target_link_libraries(heif-test heif)

=== libheif/plugins/CMakeLists.txt ===

macro(plugin_compilation name varName foundName optionName defineName)
    if (${foundName} AND WITH_${optionName})
        if (PLUGIN_LOADING_SUPPORTED_AND_ENABLED AND WITH_${optionName}_PLUGIN)
            message("Compiling '" ${name} "' as dynamic plugin")
            add_library(heif-${name}
                    MODULE ${${optionName}_sources} ${${optionName}_extra_plugin_sources}
                    ../api/libheif/heif_plugin.cc
                    )
            if (NOT APPLE)
                set_target_properties(heif-${name}
                        PROPERTIES
                        VERSION ${PROJECT_VERSION}
                        SOVERSION ${PROJECT_VERSION_MAJOR})
            endif ()
            target_compile_definitions(heif-${name}
                    PUBLIC
                    LIBHEIF_EXPORTS
                    HAVE_VISIBILITY)
            target_compile_definitions(heif-${name} PRIVATE PLUGIN_${defineName}=1)
            target_include_directories(heif-${name} PRIVATE ${PROJECT_SOURCE_DIR} ${libheif_BINARY_DIR} ${libheif_SOURCE_DIR}/libheif ${libheif_SOURCE_DIR}/libheif/api ${${varName}_INCLUDE_DIRS})
            target_link_libraries(heif-${name} PRIVATE ${${varName}_LIBRARIES} heif)

            install(TARGETS heif-${name}
                    LIBRARY DESTINATION ${COMPUTED_PLUGIN_INSTALL_DIRECTORY}
                    )
        else ()
            message("Compiling '" ${name} "' as built-in backend")
            target_sources(heif PRIVATE ${${optionName}_sources})
            target_compile_definitions(heif PRIVATE HAVE_${defineName}=1)
            target_include_directories(heif PRIVATE ${${varName}_INCLUDE_DIRS})
            target_link_directories(heif PRIVATE ${${varName}_LINK_DIRS})
            if (${varName}_DEBUG_LIBRARY)
                target_link_libraries(heif PRIVATE debug ${${varName}_DEBUG_LIBRARY})
                target_link_libraries(heif PRIVATE optimized ${${varName}_LIBRARIES})
            else()
                target_link_libraries(heif PRIVATE ${${varName}_LIBRARIES})
            endif()
        endif ()

        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${${varName}_CFLAGS}")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${varName}_CFLAGS}")
    else()
        message("Not compiling '" ${name} "' backend")
    endif ()
endmacro()

set(X265_sources encoder_x265.h encoder_x265.cc)
set(X265_extra_plugin_sources)
plugin_compilation(x265 X265 X265_FOUND X265 X265)

set(LIBDE265_sources decoder_libde265.cc decoder_libde265.h)
set(LIBDE265_extra_plugin_sources ../error.cc)
plugin_compilation(libde265 LIBDE265 LIBDE265_FOUND LIBDE265 LIBDE265)

set(DAV1D_sources decoder_dav1d.cc decoder_dav1d.h)
set(DAV1D_extra_plugin_sources ../common_utils.cc ../common_utils.h)
plugin_compilation(dav1d DAV1D DAV1D_FOUND DAV1D DAV1D)

set(AOM_DECODER_sources decoder_aom.cc decoder_aom.h)
set(AOM_DECODER_extra_plugin_sources)
plugin_compilation(aomdec AOM AOM_DECODER_FOUND AOM_DECODER AOM_DECODER)

set(AOM_ENCODER_sources encoder_aom.cc encoder_aom.h)
set(AOM_ENCODER_extra_plugin_sources ../error.cc ../common_utils.cc ../common_utils.h)
plugin_compilation(aomenc AOM AOM_ENCODER_FOUND AOM_ENCODER AOM_ENCODER)

set(SvtEnc_sources encoder_svt.cc encoder_svt.h)
set(SvtEnc_extra_plugin_sources ../common_utils.cc ../common_utils.h)
plugin_compilation(svtenc SvtEnc SvtEnc_FOUND SvtEnc SvtEnc)

set(RAV1E_sources encoder_rav1e.cc encoder_rav1e.h)
set(RAV1E_extra_plugin_sources ../error.cc)
plugin_compilation(rav1e RAV1E RAV1E_FOUND RAV1E RAV1E)

set(JPEG_DECODER_sources decoder_jpeg.cc decoder_jpeg.h)
set(JPEG_DECODER_extra_plugin_sources)
plugin_compilation(jpegdec JPEG JPEG_FOUND JPEG_DECODER JPEG_DECODER)

set(JPEG_ENCODER_sources encoder_jpeg.cc encoder_jpeg.h)
set(JPEG_ENCODER_extra_plugin_sources)
plugin_compilation(jpegenc JPEG JPEG_FOUND JPEG_ENCODER JPEG_ENCODER)

set(OpenJPEG_DECODER_sources decoder_openjpeg.cc decoder_openjpeg.h)
set(OpenJPEG_DECODER_extra_plugin_sources ) 
plugin_compilation(j2kdec OPENJPEG OPENJPEG_FOUND OpenJPEG_DECODER OPENJPEG_DECODER)

set(OpenJPEG_ENCODER_sources encoder_openjpeg.cc encoder_openjpeg.h)
set(OpenJPEG_ENCODER_extra_plugin_sources)
plugin_compilation(j2kenc OPENJPEG OPENJPEG_FOUND OpenJPEG_ENCODER OPENJPEG_ENCODER)

set(KVAZAAR_sources encoder_kvazaar.cc encoder_kvazaar.h)
set(KVAZAAR_extra_plugin_sources)
plugin_compilation(kvazaar KVAZAAR KVAZAAR_FOUND KVAZAAR KVAZAAR)

set(FFMPEG_DECODER_sources decoder_ffmpeg.cc decoder_ffmpeg.h)
set(FFMPEG_DECODER_extra_plugin_sources ../error.cc nalu_utils.cc)
plugin_compilation(ffmpegdec FFMPEG FFMPEG_FOUND FFMPEG_DECODER FFMPEG_DECODER)

set(OPENJPH_ENCODER_sources encoder_openjph.cc encoder_openjph.h)
set(OPENJPH_ENCODER_extra_plugin_sources)
plugin_compilation(jphenc OPENJPH OPENJPH_FOUND OPENJPH_ENCODER OPENJPH_ENCODER)

set(UVG266_sources encoder_uvg266.cc encoder_uvg266.h)
set(UVG266_extra_plugin_sources)
plugin_compilation(uvg266 UVG266 UVG266_FOUND UVG266 UVG266)

set(VVDEC_sources decoder_vvdec.cc decoder_vvdec.h)
set(VVDEC_extra_plugin_sources)
plugin_compilation(vvdec vvdec vvdec_FOUND VVDEC VVDEC)

set(VVENC_sources encoder_vvenc.cc encoder_vvenc.h)
set(VVENC_extra_plugin_sources)
plugin_compilation(vvenc vvenc vvenc_FOUND VVENC VVENC)

set(OpenH264_DECODER_sources decoder_openh264.cc decoder_openh264.h)
set(OpenH264_DECODER_extra_plugin_sources)
plugin_compilation(openh264dec OpenH264 OpenH264_DECODER_FOUND OpenH264_DECODER OpenH264_DECODER)

target_sources(heif PRIVATE
               encoder_mask.h
               encoder_mask.cc
               nalu_utils.h
               nalu_utils.cc)

if (WITH_UNCOMPRESSED_CODEC)
    target_sources(heif PRIVATE
            encoder_uncompressed.h
            encoder_uncompressed.cc
            decoder_uncompressed.h
            decoder_uncompressed.cc)
endif ()

=== debian/changelog ===
libheif (1.19.7-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Joachim Bauch <fancycode@debian.org>  Mon, 24 Mar 2025 16:02:48 +0100

libheif (1.19.7-1) unstable; urgency=medium

  * New upstream version 1.19.7
  * Remove patch no longer necessary with new upstream version.

 -- Joachim Bauch <fancycode@debian.org>  Mon, 10 Mar 2025 13:46:58 +0100

=== debian/rules ===
--- 
+++ 
@@ -24,6 +24,7 @@
 		-DCMAKE_INSTALL_INCLUDEDIR=include/$(DEB_HOST_MULTIARCH) \
 		-DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" \
 		-DPLUGIN_DIRECTORY=/usr/lib/$(DEB_HOST_MULTIARCH)/libheif/plugins \
+		-DCMAKE_COMPILE_WARNING_AS_ERROR=OFF \
 		-DWITH_AOM_DECODER_PLUGIN=ON \
 		-DWITH_AOM_ENCODER_PLUGIN=ON \
 		-DWITH_DAV1D=ON \

## libheif 1.19.8

=== libheif/CMakeLists.txt ===
include(CMakePackageConfigHelpers)

configure_file(api/libheif/heif_version.h.in ${CMAKE_CURRENT_BINARY_DIR}/heif_version.h)

set(libheif_headers
        api/libheif/heif.h
        api/libheif/heif_cxx.h
        api/libheif/heif_plugin.h
        api/libheif/heif_properties.h
        api/libheif/heif_regions.h
        api/libheif/heif_items.h
        ${CMAKE_CURRENT_BINARY_DIR}/heif_version.h)

set(libheif_sources
        bitstream.cc
        bitstream.h
        box.cc
        box.h
        error.cc
        error.h
        context.cc
        context.h
        file.cc
        file.h
        file_layout.h
        file_layout.cc
        pixelimage.cc
        pixelimage.h
        plugin_registry.cc
        nclx.cc
        nclx.h
        plugin_registry.h
        security_limits.cc
        security_limits.h
        init.cc
        init.h
        logging.h
        logging.cc
        compression.h
        compression_brotli.cc
        compression_zlib.cc
        common_utils.cc
        common_utils.h
        region.cc
        region.h
        api/libheif/api_structs.h
        api/libheif/heif.cc
        api/libheif/heif_regions.cc
        api/libheif/heif_plugin.cc
        api/libheif/heif_properties.cc
        api/libheif/heif_items.cc
        codecs/decoder.h
        codecs/decoder.cc
        image-items/hevc.cc
        image-items/hevc.h
        codecs/hevc_boxes.cc
        codecs/hevc_boxes.h
        codecs/hevc_dec.cc
        codecs/hevc_dec.h
        image-items/avif.cc
        image-items/avif.h
        codecs/avif_dec.cc
        codecs/avif_dec.h
        codecs/avif_boxes.cc
        codecs/avif_boxes.h
        image-items/jpeg.h
        image-items/jpeg.cc
        codecs/jpeg_boxes.h
        codecs/jpeg_boxes.cc
        codecs/jpeg_dec.h
        codecs/jpeg_dec.cc
        image-items/jpeg2000.h
        image-items/jpeg2000.cc
        codecs/jpeg2000_dec.h
        codecs/jpeg2000_dec.cc
        codecs/jpeg2000_boxes.h
        codecs/jpeg2000_boxes.cc
        image-items/vvc.h
        image-items/vvc.cc
        codecs/vvc_dec.h
        codecs/vvc_dec.cc
        codecs/vvc_boxes.h
        codecs/vvc_boxes.cc
        image-items/avc.h
        image-items/avc.cc
        codecs/avc_boxes.h
        codecs/avc_boxes.cc
        codecs/avc_dec.h
        codecs/avc_dec.cc
        image-items/mask_image.h
        image-items/mask_image.cc
        image-items/image_item.h
        image-items/image_item.cc
        image-items/grid.h
        image-items/grid.cc
        image-items/overlay.h
        image-items/overlay.cc
        image-items/iden.h
        image-items/iden.cc
        image-items/tiled.h
        image-items/tiled.cc
        color-conversion/colorconversion.cc
        color-conversion/colorconversion.h
        color-conversion/rgb2yuv.cc
        color-conversion/rgb2yuv.h
        color-conversion/rgb2yuv_sharp.cc
        color-conversion/rgb2yuv_sharp.h
        color-conversion/yuv2rgb.cc
        color-conversion/yuv2rgb.h
        color-conversion/rgb2rgb.cc
        color-conversion/rgb2rgb.h
        color-conversion/monochrome.cc
        color-conversion/monochrome.h
        color-conversion/hdr_sdr.cc
        color-conversion/hdr_sdr.h
        color-conversion/alpha.cc
        color-conversion/alpha.h
        color-conversion/chroma_sampling.cc
        color-conversion/chroma_sampling.h
        ${libheif_headers})

add_library(heif ${libheif_sources})

if (ENABLE_PLUGIN_LOADING)
    if (WIN32)
        target_sources(heif PRIVATE plugins_windows.cc plugins_windows.h)
    else ()
        target_sources(heif PRIVATE plugins_unix.cc plugins_unix.h)
    endif ()
endif ()

option(ENABLE_EXPERIMENTAL_FEATURES "Compile experimental features and install headers with unstable API" OFF)
if (ENABLE_EXPERIMENTAL_FEATURES)
    target_sources(heif PRIVATE api/libheif/heif_experimental.h api/libheif/heif_experimental.cc)

    list(APPEND libheif_headers api/libheif/heif_experimental.h)

    target_compile_definitions(heif PUBLIC HEIF_ENABLE_EXPERIMENTAL_FEATURES)
endif()

# Needed to find libheif/heif_version.h while compiling the library
target_include_directories(heif PRIVATE ${libheif_BINARY_DIR} ${libheif_SOURCE_DIR}/libheif ${libheif_SOURCE_DIR}/libheif/api)

# Propagate include/libheif to consume the headers from other projects
target_include_directories(heif
        PUBLIC
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/${PROJECT_NAME}>
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

set_target_properties(heif
        PROPERTIES
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR})

if (APPLE)
    set_target_properties(heif PROPERTIES
	    LINK_FLAGS "-Wl,-compatibility_version,${MACOS_COMPATIBLE_VERSION}")
endif ()

if (BUILD_FRAMEWORK) 
  set_target_properties(heif PROPERTIES
    FRAMEWORK TRUE
    FRAMEWORK_VERSION "${PACKAGE_VERSION}"
    PRODUCT_BUNDLE_IDENTIFIER "github.com/strukturag/libheif"
    XCODE_ATTRIBUTE_INSTALL_PATH "@rpath"
    # OUTPUT_NAME "heif"
    XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY ""
    XCODE_ATTRIBUTE_CODE_SIGNING_ALLOWED "NO"
    XCODE_ATTRIBUTE_CODE_SIGNING_REQUIRED "NO"
    PUBLIC_HEADER "${libheif_headers}"
    MACOSX_FRAMEWORK_IDENTIFIER "github.com/strukturag/libheif"
    MACOSX_FRAMEWORK_BUNDLE_VERSION "${PACKAGE_VERSION}"
    MACOSX_FRAMEWORK_SHORT_VERSION_STRING "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
    MACOSX_RPATH TRUE)
endif()

target_compile_definitions(heif
        PUBLIC
        LIBHEIF_EXPORTS
        HAVE_VISIBILITY)

if (PLUGIN_LOADING_SUPPORTED_AND_ENABLED)
    target_compile_definitions(heif PRIVATE ENABLE_PLUGIN_LOADING=1)
    target_link_libraries(heif PRIVATE ${CMAKE_DL_LIBS})
endif ()

add_subdirectory(plugins)

if (LIBSHARPYUV_FOUND)
    message("Compiling in 'libsharpyuv'")
    target_compile_definitions(heif PUBLIC HAVE_LIBSHARPYUV=1)
    target_include_directories(heif PRIVATE ${LIBSHARPYUV_INCLUDE_DIRS})
    target_link_libraries(heif PRIVATE ${LIBSHARPYUV_LIBRARIES})
else ()
    message("Not compiling 'libsharpyuv'")
endif ()

if (ZLIB_FOUND)
    target_compile_definitions(heif PRIVATE HAVE_ZLIB=1)
    target_link_libraries(heif PRIVATE ZLIB::ZLIB)
endif ()

if (Brotli_FOUND)
    target_compile_definitions(heif PUBLIC HAVE_BROTLI=1)
    target_include_directories(heif PRIVATE ${BROTLI_INCLUDE_DIRS})
    target_link_libraries(heif PRIVATE ${BROTLI_LIBS})
endif()

if (ENABLE_MULTITHREADING_SUPPORT)
    find_package(Threads)
    target_link_libraries(heif PRIVATE ${CMAKE_THREAD_LIBS_INIT})

    target_compile_definitions(heif PRIVATE ENABLE_MULTITHREADING_SUPPORT=1)
    if (ENABLE_PARALLEL_TILE_DECODING)
        target_compile_definitions(heif PRIVATE ENABLE_PARALLEL_TILE_DECODING=1)
    endif ()
endif ()

if (WITH_UNCOMPRESSED_CODEC)
    target_compile_definitions(heif PUBLIC WITH_UNCOMPRESSED_CODEC=1)
    target_sources(heif PRIVATE
            codecs/uncompressed/unc_boxes.h
            codecs/uncompressed/unc_boxes.cc
            image-items/unc_image.h
            image-items/unc_image.cc
            codecs/uncompressed/unc_codec.h
            codecs/uncompressed/unc_codec.cc
            codecs/uncompressed/unc_dec.h
            codecs/uncompressed/unc_dec.cc
            codecs/uncompressed/decoder_abstract.h
            codecs/uncompressed/decoder_abstract.cc
            codecs/uncompressed/decoder_component_interleave.h
            codecs/uncompressed/decoder_component_interleave.cc
            codecs/uncompressed/decoder_pixel_interleave.h
            codecs/uncompressed/decoder_pixel_interleave.cc
            codecs/uncompressed/decoder_mixed_interleave.h
            codecs/uncompressed/decoder_mixed_interleave.cc
            codecs/uncompressed/decoder_row_interleave.h
            codecs/uncompressed/decoder_row_interleave.cc
            codecs/uncompressed/decoder_tile_component_interleave.h
            codecs/uncompressed/decoder_tile_component_interleave.cc)
endif ()

if (ENABLE_EXPERIMENTAL_MINI_FORMAT)
    target_compile_definitions(heif PUBLIC ENABLE_EXPERIMENTAL_MINI_FORMAT=1)
    target_sources(heif PRIVATE
            mini.h
            mini.cc)
endif ()

write_basic_package_version_file(${PROJECT_NAME}-config-version.cmake COMPATIBILITY ExactVersion)

install(TARGETS heif EXPORT ${PROJECT_NAME}-config
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        FRAMEWORK DESTINATION Library/Frameworks COMPONENT runtime OPTIONAL
        )

install(FILES ${libheif_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})

install(EXPORT ${PROJECT_NAME}-config DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake DESTINATION
        "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")


# --- on Windows, copy the DLL into the executable directory for easier development

if (WIN32 AND BUILD_SHARED_LIBS)
    add_custom_command(TARGET heif POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy
            $<TARGET_FILE:heif>
            $<TARGET_FILE_DIR:heif>/../examples
    )
endif ()

=== debian/changelog ===
libheif (1.19.8-1) unstable; urgency=medium

  * New upstream version 1.19.8
  * d/control: Update Standards-Version to 4.7.2

 -- Joachim Bauch <fancycode@debian.org>  Tue, 29 Apr 2025 10:32:58 +0200

=== debian/control ===
--- 
+++ 
@@ -13,16 +13,18 @@
  libde265-dev (>= 1.0.7),
  libgdk-pixbuf-2.0-dev,
  libjpeg-dev,
+ libkvazaar-dev,
  libopenjp2-7-dev,
  libpng-dev,
 # librav1e-dev is built by src:rust-rav1e which is not available on all platforms.
 # Make sure to use the same list in the "libheif-plugin-rav1e" package below.
  librav1e-dev [amd64 arm64 armel armhf mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x],
+ libsharpyuv-dev,
  libsvtav1enc-dev,
  libx265-dev,
  libz-dev,
  pkgconf
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: http://www.libheif.org
 Vcs-Git: https://salsa.debian.org/multimedia-team/libheif.git
@@ -46,6 +48,7 @@
  libheif-plugin-jpegenc (= ${binary:Version}),
  libheif-plugin-j2kdec (= ${binary:Version}),
  libheif-plugin-j2kenc (= ${binary:Version}),
+ libheif-plugin-kvazaar (= ${binary:Version}),
  libheif-plugin-rav1e (= ${binary:Version}) [amd64 arm64 armel armhf mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x],
  libheif-plugin-svtenc (= ${binary:Version})
 Description: HEIF and AVIF file format decoder and encoder - shared library
@@ -242,6 +245,29 @@
  .
  libjpeg: https://www.libjpeg-turbo.org/
 
+Package: libheif-plugin-kvazaar
+Architecture: any
+Multi-Arch: same
+Depends:
+ libheif1 (= ${binary:Version}),
+ ${misc:Depends},
+ ${shlibs:Depends}
+Description: HEIF and AVIF file format decoder and encoder - kvazaar plugin
+ libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
+ format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
+ (2nd Edition) capabilities.
+ .
+ HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
+ coding, respectively, for the best compression ratios currently possible.
+ .
+ libheif supports various codecs provided by plugins for image decoding and
+ encoding.
+ .
+ This package contains the kvazaar plugin that uses kvazaar to encode HEVC
+ images.
+ .
+ kvazaar: https://ultravideo.fi/kvazaar.html
+
 Package: libheif-plugin-libde265
 Architecture: any
 Multi-Arch: same
@@ -317,26 +343,3 @@
  ${misc:Depends},
  ${shlibs:Depends}
 Description: HEIF and AVIF file format decoder and encoder - x265 plugin
- libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
- format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
- (2nd Edition) capabilities.
- .
- HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
- coding, respectively, for the best compression ratios currently possible.
- .
- libheif supports various codecs provided by plugins for image decoding and
- encoding.
- .
- This package contains the x265 plugin that uses x265 to encode HEVC images.
- .
- x265: https://www.videolan.org/developers/x265.html
-
-Package: libheif-plugins-all
-Architecture: any
-Multi-Arch: same
-Depends:
- libheif-plugin-aomdec (>= ${source:Version}),
- libheif-plugin-aomenc (>= ${source:Version}),
- libheif-plugin-dav1d (>= ${source:Version}),
- libheif-plugin-ffmpegdec (>= ${source:Version}),
- libheif-plugin-j2kdec (>= ${source:Version}),

=== debian/rules ===
--- 
+++ 
@@ -36,7 +36,10 @@
 		-DWITH_JPEG_DECODER_PLUGIN=ON \
 		-DWITH_JPEG_ENCODER=ON \
 		-DWITH_JPEG_ENCODER_PLUGIN=ON \
+		-DWITH_KVAZAAR=ON \
+		-DWITH_KVAZAAR_PLUGIN=ON \
 		-DWITH_LIBDE265_PLUGIN=ON \
+		-DWITH_LIBSHARPYUV=ON \
 		-DWITH_OpenJPEG_DECODER=ON \
 		-DWITH_OpenJPEG_DECODER_PLUGIN=ON \
 		-DWITH_OpenJPEG_ENCODER=ON \

## libheif 1.20.1

=== debian/changelog ===
libheif (1.20.1-1) experimental; urgency=medium

  * New upstream version 1.20.1
  * New upstream version 1.20.1
  * Add patch to fix undefined symbol in svtenc plugin.
  * Update symbols for new upstream version.
  * Add "heif-view" binary package.
  * Add patch to load (encoding) plugins earlier.

 -- Joachim Bauch <fancycode@debian.org>  Mon, 28 Jul 2025 11:41:29 +0200
